(* file: isPrime.ml
 * author: Bob Muller
 *
 * CS1101 Computer Science I
 *
 * This is a simple program for primality testing. Another
 * example showing repetition.
 *
 * sqrtInt : int -> int
 *)
let sqrtInt n = int_of_float (sqrt (float_of_int n))

(* isFactor : int -> int -> bool 
 *)
let isFactor m n = n mod m = 0
			   
(* isPrime : int -> bool
 *
 * Try all the integers between 2 and the square root of n to see
 * if they are factors of n.
 *)
let isPrime n =
  let top = sqrtInt n in
  let rec again m =
    match m > top with
    | true  -> true
    | false -> (match isFactor m n with
		| true  -> false 
		| false -> again (m + 1))
  in
  again 2
