(* file: power.ml 
 * author: Bob Muller
 * 
 * CS1101 Computer Science I
 *
 * A simple exercise for expressing repetition with recursion.
 *
 * power : int -> int -> int
 *
 * The call (power m n) returns m^n.
 *)
let rec power m n =
  match n = 0 with
  | true  -> 1
  | false -> m * (power m (n - 1))

(* A tail-recursive version. The slightly simpler version above 
 * generally requires an amount of storage space that is linear
 * in the size of n. The following tail-recursive version can be
 * implemented in an amount of storage space that is fixed.
 *)
let power m n =
  let rec loop n acc =
    match n = 0 with
    | true  -> acc
    | false -> loop (n - 1) (m * acc)
  in
  loop n 1
